Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/IntegerExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/IntegerExpressionTests.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/IntegerExpressionTests.cs	(revision 14513)
@@ -1,297 +1,308 @@
-﻿using HeuristicLab.Algorithms.PushGP.Expressions;
-using HeuristicLab.Algorithms.PushGP.Stack;
-using Microsoft.VisualStudio.TestTools.UnitTesting;
-
-namespace HeuristicLab.Tests.Interpreter.Expressions
+﻿namespace HeuristicLab.Tests.Interpreter.Expressions
 {
-    [TestClass]
-    public class IntegerExpressionTests : CommonTests<long>
-    {
-        protected override string TypeName { get { return "INTEGER"; } }
-        protected override IStack<long> Stack { get { return interpreter.IntegerStack; } }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestAdd()
-        {
-            interpreter.IntegerStack.Push(5, 5);
-            interpreter.Interpret(new IntegerAddExpression());
-
-            Assert.AreEqual(10, interpreter.IntegerStack.Top);
-
-            TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestAddWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("+", 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestSubtract()
-        {
-            interpreter.IntegerStack.Push(10, 5);
-            interpreter.Interpret(new IntegerSubtractExpression());
-
-            Assert.AreEqual(5, interpreter.IntegerStack.Top);
-
-            TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestSubtractWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("-", 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestMultiply()
-        {
-            interpreter.IntegerStack.Push(10, 5);
-            interpreter.Interpret(new IntegerMultiplyExpression());
-
-            Assert.AreEqual(50, interpreter.IntegerStack.Top);
-
-            TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestMultiplyWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("*", 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestDivide()
-        {
-            interpreter.IntegerStack.Push(10, 5);
-            interpreter.Interpret(new IntegerDivideExpression());
-
-            Assert.AreEqual(2, interpreter.IntegerStack.Top);
-
-            TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestDivideWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("/", 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestModulo()
-        {
-            interpreter.IntegerStack.Push(10, 5);
-            interpreter.Interpret(new IntegerModuloExpression());
-
-            Assert.AreEqual(0, interpreter.IntegerStack.Top);
-
-            TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestModuloWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("%", 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestMin()
-        {
-            interpreter.IntegerStack.Push(10, 5);
-            interpreter.Interpret(new IntegerMinExpression());
-
-            Assert.AreEqual(5, interpreter.IntegerStack.Top);
-
-            TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestMinWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("MIN", 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestMax()
-        {
-            interpreter.IntegerStack.Push(10, 5);
-            interpreter.Interpret(new IntegerMaxExpression());
-
-            Assert.AreEqual(10, interpreter.IntegerStack.Top);
-
-            TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestMaxWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("MAX", 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestSmallerThan()
-        {
-            interpreter.IntegerStack.Push(10, 5);
-            interpreter.Interpret(new IntegerSmallerThanExpression());
-
-            Assert.AreEqual(false, interpreter.BooleanStack.Top);
-
-            TestStackCounts(booleanStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestSmallerThanWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("<", 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestGreaterThan()
-        {
-            interpreter.IntegerStack.Push(10, 5);
-            interpreter.Interpret(new IntegerGreaterThanExpression());
-
-            Assert.AreEqual(true, interpreter.BooleanStack.Top);
-
-            TestStackCounts(booleanStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestGreaterThanWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments(">", 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestFromBooleanTrue()
-        {
-            interpreter.BooleanStack.Push(true);
-            interpreter.Interpret(new IntegerFromBooleanExpression());
-
-            Assert.AreEqual(1, interpreter.IntegerStack.Top);
-
-            TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestFromBooleanWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("FROMBOOLEAN");
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestFromBooleanFalse()
-        {
-            interpreter.BooleanStack.Push(false);
-            interpreter.Interpret(new IntegerFromBooleanExpression());
-
-            Assert.AreEqual(0, interpreter.IntegerStack.Top);
-
-            TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestFromFloat()
-        {
-            interpreter.FloatStack.Push(1.5);
-            interpreter.Interpret(new IntegerFromFloatExpression());
-
-            Assert.AreEqual(1, interpreter.IntegerStack.Top);
-
-            TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("IntegerExpressionTest")]
-        public void TestFromFloatWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("FROMFLOAT");
-        }
-
-        protected override long[] GetValues(int count)
-        {
-            var values = new long[count];
-
-            for (long i = 0; i < count; i++)
-            {
-                values[i] = i;
-            }
-
-            return values;
-        }
-
-        protected override void CheckOtherStacksAreEmpty()
-        {
-            TestStackCounts(integerStack: null);
-        }
-    }
+  using HeuristicLab.Algorithms.PushGP.Expressions;
+  using HeuristicLab.Algorithms.PushGP.Stack;
+
+  using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+  [TestClass]
+  public class IntegerExpressionTests : CommonTests<long>
+  {
+    protected override string TypeName
+    {
+      get
+      {
+        return "INTEGER";
+      }
+    }
+
+    protected override IStack<long> Stack
+    {
+      get
+      {
+        return this.interpreter.IntegerStack;
+      }
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestAdd()
+    {
+      this.interpreter.IntegerStack.Push(5, 5);
+      this.interpreter.Interpret(new IntegerAddExpression());
+
+      Assert.AreEqual(10, this.interpreter.IntegerStack.Top);
+
+      this.TestStackCounts(integerStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestAddWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("+", 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestSubtract()
+    {
+      this.interpreter.IntegerStack.Push(10, 5);
+      this.interpreter.Interpret(new IntegerSubtractExpression());
+
+      Assert.AreEqual(5, this.interpreter.IntegerStack.Top);
+
+      this.TestStackCounts(integerStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestSubtractWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("-", 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestMultiply()
+    {
+      this.interpreter.IntegerStack.Push(10, 5);
+      this.interpreter.Interpret(new IntegerMultiplyExpression());
+
+      Assert.AreEqual(50, this.interpreter.IntegerStack.Top);
+
+      this.TestStackCounts(integerStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestMultiplyWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("*", 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestDivide()
+    {
+      this.interpreter.IntegerStack.Push(10, 5);
+      this.interpreter.Interpret(new IntegerDivideExpression());
+
+      Assert.AreEqual(2, this.interpreter.IntegerStack.Top);
+
+      this.TestStackCounts(integerStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestDivideWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("/", 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestModulo()
+    {
+      this.interpreter.IntegerStack.Push(10, 5);
+      this.interpreter.Interpret(new IntegerModuloExpression());
+
+      Assert.AreEqual(0, this.interpreter.IntegerStack.Top);
+
+      this.TestStackCounts(integerStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestModuloWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("%", 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestMin()
+    {
+      this.interpreter.IntegerStack.Push(10, 5);
+      this.interpreter.Interpret(new IntegerMinExpression());
+
+      Assert.AreEqual(5, this.interpreter.IntegerStack.Top);
+
+      this.TestStackCounts(integerStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestMinWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("MIN", 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestMax()
+    {
+      this.interpreter.IntegerStack.Push(10, 5);
+      this.interpreter.Interpret(new IntegerMaxExpression());
+
+      Assert.AreEqual(10, this.interpreter.IntegerStack.Top);
+
+      this.TestStackCounts(integerStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestMaxWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("MAX", 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestSmallerThan()
+    {
+      this.interpreter.IntegerStack.Push(10, 5);
+      this.interpreter.Interpret(new IntegerSmallerThanExpression());
+
+      Assert.AreEqual(false, this.interpreter.BooleanStack.Top);
+
+      this.TestStackCounts(booleanStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestSmallerThanWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("<", 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestGreaterThan()
+    {
+      this.interpreter.IntegerStack.Push(10, 5);
+      this.interpreter.Interpret(new IntegerGreaterThanExpression());
+
+      Assert.AreEqual(true, this.interpreter.BooleanStack.Top);
+
+      this.TestStackCounts(booleanStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestGreaterThanWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments(">", 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestFromBooleanTrue()
+    {
+      this.interpreter.BooleanStack.Push(true);
+      this.interpreter.Interpret(new IntegerFromBooleanExpression());
+
+      Assert.AreEqual(1, this.interpreter.IntegerStack.Top);
+
+      this.TestStackCounts(integerStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestFromBooleanWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("FROMBOOLEAN");
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestFromBooleanFalse()
+    {
+      this.interpreter.BooleanStack.Push(false);
+      this.interpreter.Interpret(new IntegerFromBooleanExpression());
+
+      Assert.AreEqual(0, this.interpreter.IntegerStack.Top);
+
+      this.TestStackCounts(integerStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestFromFloat()
+    {
+      this.interpreter.FloatStack.Push(1.5);
+      this.interpreter.Interpret(new IntegerFromFloatExpression());
+
+      Assert.AreEqual(1, this.interpreter.IntegerStack.Top);
+
+      this.TestStackCounts(integerStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("IntegerExpressionTest")]
+    public void TestFromFloatWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("FROMFLOAT");
+    }
+
+    protected override long[] GetValues(int count)
+    {
+      var values = new long[count];
+
+      for (long i = 0; i < count; i++) values[i] = i;
+
+      return values;
+    }
+
+    protected override void CheckOtherStacksAreEmpty()
+    {
+      this.TestStackCounts(integerStack: null);
+    }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/NameExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/NameExpressionTests.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/NameExpressionTests.cs	(revision 14513)
@@ -1,85 +1,95 @@
-﻿using HeuristicLab.Algorithms.PushGP.Expressions;
-using HeuristicLab.Algorithms.PushGP.Generators;
-using HeuristicLab.Algorithms.PushGP.Stack;
-using Microsoft.VisualStudio.TestTools.UnitTesting;
+﻿namespace HeuristicLab.Tests.Interpreter.Expressions
+{
+  using HeuristicLab.Algorithms.PushGP.Expressions;
+  using HeuristicLab.Algorithms.PushGP.Generators;
+  using HeuristicLab.Algorithms.PushGP.Stack;
 
-namespace HeuristicLab.Tests.Interpreter.Expressions
-{
-    [TestClass]
-    public class NameExpressionTests : CommonTests<string>
+  using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+  [TestClass]
+  public class NameExpressionTests : CommonTests<string>
+  {
+    protected override string TypeName
     {
+      get
+      {
+        return "NAME";
+      }
+    }
 
-        protected override string TypeName { get { return "NAME"; } }
-        protected override IStack<string> Stack { get { return interpreter.NameStack; } }
+    protected override IStack<string> Stack
+    {
+      get
+      {
+        return this.interpreter.NameStack;
+      }
+    }
 
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("NameExpressionTest")]
-        public void TestRand()
-        {
-            interpreter.Interpret(new NameRandExpression());
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("NameExpressionTest")]
+    public void TestRand()
+    {
+      this.interpreter.Interpret(new NameRandExpression());
 
-            Assert.IsTrue(interpreter.NameStack.Count == 1);
+      Assert.IsTrue(this.interpreter.NameStack.Count == 1);
 
-            CheckOtherStacksAreEmpty();
-        }
+      this.CheckOtherStacksAreEmpty();
+    }
 
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("NameExpressionTest")]
-        public void TestRandomBound()
-        {
-            interpreter.CustomExpressions.Add("c1", new CodeNoopExpression());
-            interpreter.CustomExpressions.Add("c2", new CodeNoopExpression());
-            interpreter.CustomExpressions.Add("c3", new CodeNoopExpression());
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("NameExpressionTest")]
+    public void TestRandomBound()
+    {
+      this.interpreter.CustomExpressions.Add("c1", new CodeNoopExpression());
+      this.interpreter.CustomExpressions.Add("c2", new CodeNoopExpression());
+      this.interpreter.CustomExpressions.Add("c3", new CodeNoopExpression());
 
-            interpreter.Interpret(new NameRandBoundNameExpression());
+      this.interpreter.Interpret(new NameRandBoundNameExpression());
 
-            Assert.IsTrue(interpreter.CustomExpressions.Keys.Contains(interpreter.NameStack.Top));
+      Assert.IsTrue(this.interpreter.CustomExpressions.Keys.Contains(this.interpreter.NameStack.Top));
 
-            CheckOtherStacksAreEmpty();
-        }
+      this.CheckOtherStacksAreEmpty();
+    }
 
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("NameExpressionTest")]
-        public void TestRandomBoundWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("RANDBOUNDNAME");
-        }
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("NameExpressionTest")]
+    public void TestRandomBoundWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("RANDBOUNDNAME");
+    }
 
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("NameExpressionTest")]
-        public void TestQuote()
-        {
-            interpreter.Interpret(new NameQuoteExpression());
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("NameExpressionTest")]
+    public void TestQuote()
+    {
+      this.interpreter.Interpret(new NameQuoteExpression());
 
-            Assert.IsTrue(interpreter.IsNameQuoteFlagSet);
+      Assert.IsTrue(this.interpreter.IsNameQuoteFlagSet);
 
-            TestStackCounts();
-        }
+      this.TestStackCounts();
+    }
 
-        protected override string[] GetValues(int count)
-        {
-            var ng = new NameGenerator();
-            var values = new string[count];
+    protected override string[] GetValues(int count)
+    {
+      var ng = new NameGenerator();
+      var values = new string[count];
 
-            for (var i = 0; i < count; i++)
-            {
-                values[i] = ng.GetNextString();
-            }
+      for (var i = 0; i < count; i++) values[i] = ng.GetNextString();
 
-            return values;
-        }
+      return values;
+    }
 
-        protected override void CheckOtherStacksAreEmpty()
-        {
-            TestStackCounts(nameStack: null);
-        }
+    protected override void CheckOtherStacksAreEmpty()
+    {
+      this.TestStackCounts(nameStack: null);
     }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/StandardTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/StandardTests.cs	(revision 14513)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/StandardTests.cs	(revision 14513)
@@ -0,0 +1,100 @@
+﻿namespace HeuristicLab.Tests.Interpreter.Expressions {
+  using System;
+  using System.Collections.Generic;
+  using System.Diagnostics;
+  using System.Linq;
+  using HeuristicLab.Algorithms.PushGP.Expressions;
+  using HeuristicLab.Algorithms.PushGP.Parser;
+
+  using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+  [TestClass]
+  public class StandardTests {
+    [TestMethod]
+    public void TestGetHashCode() {
+      var expressionTypes = from domainAssembly in AppDomain.CurrentDomain.GetAssemblies()
+                            from assemblyType in domainAssembly.GetTypes()
+                            where
+                            !assemblyType.IsAbstract && assemblyType.IsSubclassOf(typeof(Expression))
+                            && (assemblyType.GetConstructor(Type.EmptyTypes) != null)
+                            select assemblyType;
+
+      var expressions = expressionTypes.Select(et => Activator.CreateInstance(et) as Expression);
+      var ids = expressions.Select(e => new { Epxression = e, Id = e.GetHashCode() });
+
+      var duplicates = ids.GroupBy(s => s).SelectMany(grp => grp.Skip(1));
+
+      if (duplicates.Any()) {
+        Debug.WriteLine("Duplicates: ");
+        foreach (var duplicate in duplicates) Debug.WriteLine("Id: {0}, Expression: {1}", duplicate.Id, duplicate.Epxression);
+
+        Assert.Fail();
+      }
+    }
+
+    [TestMethod]
+    public void TestExpandGetHashCode() {
+      var expand = PushGPParser.Parse("( A B C D E F )");
+
+      expand.GetHashCode();
+    }
+
+    [TestMethod]
+    public void TestExecExpandCopy() {
+      var expressions = new Expression[]
+                          {
+                            new IntegerPushExpression(2), new FloatPushExpression(2.0),
+                            new BooleanPushExpression(true), new NameDefineXExecExpression("A")
+                          };
+
+      var list = new ExecExpandExpression(expressions);
+      var clone = list.Copy();
+
+      Assert.AreNotSame(list, clone);
+      Assert.AreEqual(list, clone);
+    }
+
+    [TestMethod]
+    public void TestExecExpandRecursiveCopy() {
+      var expressions = new List<Expression>
+                          {
+                            new IntegerPushExpression(2),
+                            new FloatPushExpression(2.1),
+                            new BooleanPushExpression(true),
+                            new NameDefineXExecExpression("A")
+                          };
+
+      var list = new ExecExpandExpression(expressions.ToArray());
+
+      expressions.Add(list);
+
+      var list2 = new ExecExpandExpression(expressions.ToArray());
+      var clone = list2.Copy();
+
+      Assert.AreSame(list, clone.Expressions.Last());
+      Assert.AreEqual(list, clone.Expressions.Last());
+
+      Assert.AreNotSame(list2, clone);
+      Assert.AreEqual(list2, clone);
+    }
+
+    [TestMethod]
+    public void TestExecExpandRecursiveGetHashCode() {
+      var expressions = new List<Expression>
+                          {
+                            new IntegerPushExpression(2),
+                            new FloatPushExpression(2.0),
+                            new BooleanPushExpression(true),
+                            new NameDefineXExecExpression("A")
+                          };
+
+      var list = new ExecExpandExpression(expressions.ToArray());
+
+      expressions.Add(list);
+      var list2 = new ExecExpandExpression(expressions.ToArray());
+      var list3 = new ExecExpandExpression(expressions.ToArray());
+
+      Assert.AreEqual(list2.GetHashCode(), list3.GetHashCode());
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Properties/AssemblyInfo.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Properties/AssemblyInfo.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Properties/AssemblyInfo.cs	(revision 14513)
@@ -1,4 +1,3 @@
 ﻿using System.Reflection;
-using System.Runtime.CompilerServices;
 using System.Runtime.InteropServices;
 
@@ -6,4 +5,5 @@
 // set of attributes. Change these attribute values to modify the information
 // associated with an assembly.
+
 [assembly: AssemblyTitle("HeuristicLab.Tests")]
 [assembly: AssemblyDescription("")]
@@ -18,7 +18,9 @@
 // to COM components.  If you need to access a type in this assembly from 
 // COM, set the ComVisible attribute to true on that type.
+
 [assembly: ComVisible(false)]
 
 // The following GUID is for the ID of the typelib if this project is exposed to COM
+
 [assembly: Guid("117b7d68-ed7d-4350-996b-9ca15259e107")]
 
@@ -33,4 +35,5 @@
 // by using the '*' as shown below:
 // [assembly: AssemblyVersion("1.0.*")]
+
 [assembly: AssemblyVersion("1.0.0.0")]
 [assembly: AssemblyFileVersion("1.0.0.0")]
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/PushGp.sln
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/PushGp.sln	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/PushGp.sln	(revision 14513)
@@ -11,4 +11,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.BenchmarkSuite", "HeuristicLab.BenchmarkSuite\HeuristicLab.BenchmarkSuite.csproj", "{22B5C087-CFC7-4D40-86C6-32FCF2CA921E}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.PushGP", "HeuristicLab.Problems.ProgramSynthesis\HeuristicLab.Problems.PushGP.csproj", "{5C93448C-47E3-4C3F-B1D0-EE62A48C3204}"
 EndProject
 Global
@@ -34,4 +36,8 @@
 		{22B5C087-CFC7-4D40-86C6-32FCF2CA921E}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{22B5C087-CFC7-4D40-86C6-32FCF2CA921E}.Release|Any CPU.Build.0 = Release|Any CPU
+		{5C93448C-47E3-4C3F-B1D0-EE62A48C3204}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{5C93448C-47E3-4C3F-B1D0-EE62A48C3204}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{5C93448C-47E3-4C3F-B1D0-EE62A48C3204}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{5C93448C-47E3-4C3F-B1D0-EE62A48C3204}.Release|Any CPU.Build.0 = Release|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
